import java.util.concurrent.atomic.AtomicInteger;

public class AtomicVarExample {
	private AtomicInteger atomicInteger = new AtomicInteger(0);
	private Integer regularInteger = new Integer(0);
	
	private class AtomicVarThread implements Runnable {
		public void run ( ) {
			System.out.println("Atomic Integer Value: " + atomicInteger.incrementAndGet());
		}
		
	}
	
	private class RegularVarThread implements Runnable {
		public void run ( ) {
			System.out.println("Regular Integer Value: " + (++regularInteger).toString());
		}
	}
	
	public void test ( ) {
		AtomicVarThread avt = new AtomicVarThread();
		RegularVarThread navt = new RegularVarThread();

		for (int i = 0; i < 5; i++) {
			new Thread(avt).start();
			new Thread(navt).start();
		}
	}
}
