import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.Executor;

public class ExecutorExample implements Executor {
	private static ArrayBlockingQueue<Thread> threads = new ArrayBlockingQueue<Thread>(2);
	private static int id = 0;
	
	public void execute(Runnable r, String name, int priority) {
		ThreadFactoryExample tFactory = new ThreadFactoryExample();
		Thread t = tFactory.newThread(r,name,priority);
		if (threads.offer(t)) {
			System.out.println("Thread "+t.getName()+" added to execution queue");
		}
		try {
			t = threads.take();
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		System.out.println("Thread "+t.getName()+" started with priority "+t.getPriority());
		t.start();
	}

	public void execute(Runnable c) {
		this.execute(c,"Task "+id++,Thread.NORM_PRIORITY);		
	}
	
}
